extern vec2 screenSize = vec2(800.0, 600.0);
extern vec2 lightPosition = vec2(256.0, 256.0);
extern vec4 lightColorRange = vec4(1.0, 1.0, 1.0, 200.0);

vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords) {
	vec2 pSize = vec2(1.0 / 800.0, 1.0 / 600.0);
	vec4 col = Texel(texture, texture_coords);

	vec2 screenPosition = vec2(screenSize.x * texture_coords.x, screenSize.y * texture_coords.y);
	float dist = distance(vec2(screenPosition.x, screenPosition.y), vec2(lightPosition.x, lightPosition.y));
	float att = 1 - dist / lightColorRange.a;

	if(col.a == 0.0) {
		if(dist < lightColorRange.a) {
			vec4 curPoint;
			vec3 curColor;
			float dx = lightPosition.x - screenPosition.x;
			float dy = lightPosition.y - screenPosition.y;
			int shadowQuality = 100; // set quality level
			float steps = min(shadowQuality, dist);
			float gap = 1.0 / steps;
			float collAlpha = 1.0;
			for(int i = 0; i < steps; ++i) {
				curPoint = Texel(texture, vec2((screenPosition.x + dx * i * gap) * pSize.x, (screenPosition.y + dy * i * gap) * pSize.y));
				if(curPoint.a > 0.0) {
					if(curPoint.a == 1.0) {
						collAlpha = 0.0;
						break;
					} else {
						if(collAlpha > 1 - curPoint.a) {
							collAlpha = 1 - curPoint.a;
							curColor = curPoint.rgb;
						}
					}
				}
			}
			if(collAlpha == 1.0) {
				return vec4(lightColorRange.rgb * att * att, 1.0);
			} else if(collAlpha < 1.0) {
				return vec4((lightColorRange.rgb * curColor * att * att) * collAlpha, 1.0);
			} else {
				return vec4(0.0, 0.0, 0.0, 1.0);
			}
		} else {
			return vec4(0.0, 0.0, 0.0, 1.0);
		}
	} else {
		return vec4(lightColorRange.rgb * att * att, 1.0);
	}
}